<?php

namespace SGalinski\SgNews\Domain\Repository;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Backend\Utility\BackendUtility;
use TYPO3\CMS\Core\Http\ApplicationType;
use TYPO3\CMS\Extbase\Persistence\Generic\Typo3QuerySettings;
use TYPO3\CMS\Extbase\Persistence\QueryInterface;
use TYPO3\CMS\Extbase\Persistence\Repository;
use TYPO3\CMS\Frontend\Controller\TypoScriptFrontendController;
use TYPO3\CMS\Frontend\Page\PageRepository;

/**
 * Abstract Repository
 */
abstract class AbstractRepository extends Repository {
	/**
	 * Initializes the repository default settings
	 *
	 * @return void
	 */
	public function initializeObject() {
		/** @var Typo3QuerySettings $querySettings  */
		$querySettings = $this->objectManager->get(Typo3QuerySettings::class);
		$querySettings->setRespectStoragePage(FALSE);
		// in Migration wizard it was possible tha $GLOBALS['TYPO3_REQUEST'] was not set
		// this should not be the case in any other case
		if (!isset($GLOBALS['TYPO3_REQUEST']) || ApplicationType::fromRequest($GLOBALS['TYPO3_REQUEST'])->isBackend()) {
			$querySettings->setIgnoreEnableFields(TRUE);
		}
		$this->setDefaultQuerySettings($querySettings);
	}

	/**
	 * This count returns the right amount of results, in contrast to $query->execute()->count(), which does not respect
	 * the language- nor the workspace overlay.
	 *
	 * @param QueryInterface $query The query object to use the count on
	 *
	 * @return int
	 */
	public function getCount(QueryInterface $query) {
		return \count($query->execute(TRUE));
	}
}
